이 문서는 기계 번역을 이용하여 번역되었습니다. 문서를 영문으로 보려면 영문 확인란을 선택하세요. 마우스 포인터를 텍스트 위로 이동시켜 팝업 창에서 영문 텍스트를 표시할 수도 있습니다.
번역
영문

Exception.StackTrace 속성

 

게시 날짜: 2016년 11월

호출 스택의 직접 실행 프레임 문자열 표현을 가져옵니다.

네임스페이스:   System
어셈블리:  mscorlib(mscorlib.dll에 있음)

public virtual string StackTrace { get; }

속성 값

Type: System.String

호출 스택의 직접 실행 프레임을 설명하는 문자열입니다.

실행 스택은 특정 시점에 실행 중인 모든 메서드를 추적합니다. 메서드 호출을 추적하는 것을 스택 추적이라고 합니다. 스택 추적 목록은 메서드의 줄 번호를 호출 스택을 따라 예외가 발생 하는 방법을 제공 합니다.

StackTrace 속성 예외가 throw 된 위치에서 발생 하는 호출 스택의 프레임을 반환 합니다. 새 인스턴스를 만들어 호출 스택에 추가 프레임에 대 한 정보를 얻을 수 있습니다는 System.Diagnostics.StackTrace 클래스와 사용 하 여 해당 StackTrace.ToString 메서드.

공용 언어 런타임 (CLR) 응용 프로그램 코드에서 예외가 throw 될 때마다 스택 추적을 업데이트 (사용 하 여는 throw 키워드)입니다. 메서드에서 다른 방법 보다 원래 예외가 다시 throw 된 예외, 여기서는 원래 예외가, 메서드의 위치와 예외가 다시 throw 된 위치 메서드의 위치 스택 추적 포함 됩니다. 예외가 throw 되 고 나중에 다시 throw 동일한 메서드의 경우 스택 추적은 예외가 다시 throw 된 위치와 원래 예외가 throw 된 위치를 포함 하지 않습니다 포함 됩니다.

StackTrace 속성와 같은 코드 변환으로 인해 예상 만큼 많은 메서드 호출을 보고 하지 않거나 인라인 처리를 최적화 하는 동안 발생 하는 합니다.

상속자 참고 사항:

StackTrace 속성 스택 추적 내용이 나 형식을 제어할 필요가 있는 클래스에서 재정의 됩니다.

기본적으로 스택 추적에 예외 개체를 throw 되기 직전 캡처됩니다. 사용 하 여 Environment.StackTrace 예외가 throw 되는 경우 스택 추적 정보를 얻을 수 있습니다.

다음 코드 예제에서는 throw 한 Exception 한 후 catch 하 여 스택 추적 표시는 StackTrace 속성입니다.

// Example for the Exception.HelpLink, Exception.Source,
// Exception.StackTrace, and Exception.TargetSite properties.
using System;

namespace NDP_UE_CS
{
    // Derive an exception; the constructor sets the HelpLink and 
    // Source properties.
    class LogTableOverflowException : Exception
    {
        const string overflowMessage = "The log table has overflowed.";

        public LogTableOverflowException( 
            string auxMessage, Exception inner ) :
                base( String.Format( "{0} - {1}", 
                    overflowMessage, auxMessage ), inner )
        {
            this.HelpLink = "http://msdn.microsoft.com";
            this.Source = "Exception_Class_Samples";
        }
    }

    class LogTable
    {
        public LogTable( int numElements )
        {
            logArea = new string[ numElements ];
            elemInUse = 0;
        }

        protected string[ ] logArea;
        protected int       elemInUse;

        // The AddRecord method throws a derived exception if 
        // the array bounds exception is caught.
        public    int       AddRecord( string newRecord )
        {
            try
            {
                logArea[ elemInUse ] = newRecord;
                return elemInUse++;
            }
            catch( Exception e )
            {
                throw new LogTableOverflowException( 
                    String.Format( "Record \"{0}\" was not logged.", 
                        newRecord ), e );
            }
        }
    }

    class OverflowDemo 
    {
        // Create a log table and force an overflow.
        public static void Main() 
        {
            LogTable log = new LogTable( 4 );

            Console.WriteLine( 
                "This example of \n   Exception.Message, \n" +
                "   Exception.HelpLink, \n   Exception.Source, \n" +
                "   Exception.StackTrace, and \n   Exception." +
                "TargetSite \ngenerates the following output." );

            try
            {
                for( int count = 1; ; count++ )
                {
                    log.AddRecord( 
                        String.Format( 
                            "Log record number {0}", count ) );
                }
            }
            catch( Exception ex )
            {
                Console.WriteLine( "\nMessage ---\n{0}", ex.Message );
                Console.WriteLine( 
                    "\nHelpLink ---\n{0}", ex.HelpLink );
                Console.WriteLine( "\nSource ---\n{0}", ex.Source );
                Console.WriteLine( 
                    "\nStackTrace ---\n{0}", ex.StackTrace );
                Console.WriteLine( 
                    "\nTargetSite ---\n{0}", ex.TargetSite );
            }
        }
    }
}

/*
This example of
   Exception.Message,
   Exception.HelpLink,
   Exception.Source,
   Exception.StackTrace, and
   Exception.TargetSite
generates the following output.

Message ---
The log table has overflowed. - Record "Log record number 5" was not logged.

HelpLink ---
http://msdn.microsoft.com

Source ---
Exception_Class_Samples

StackTrace ---
   at NDP_UE_CS.LogTable.AddRecord(String newRecord)
   at NDP_UE_CS.OverflowDemo.Main()

TargetSite ---
Int32 AddRecord(System.String)
*/

유니버설 Windows 플랫폼
8 이후 사용 가능
.NET Framework
1.1 이후 사용 가능
이식 가능한 클래스 라이브러리
이식 가능한 .NET 플랫폼 에서 지원됨
Silverlight
2.0 이후 사용 가능
Windows Phone Silverlight
7.0 이후 사용 가능
Windows Phone
8.1 이후 사용 가능
맨 위로 이동
표시: